Package ec.select

# Class AnnealedSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.select.AnnealedSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class AnnealedSelection extends SelectionMethod
Returns an individual using a form of simulated annealing.

This works as follows. If there is only one individual in the population, he is selected. Otherwise we pick a random individual from among the individuals other than the first individual. If that random individual is fitter than the first individual, it is selected. Otherwise if that random individual is as fit as the first individual, one of the two is selected at random. Otherwise if the random individual is not as fit as the first individual, it is selected with a probability P = e^((fit(random ind) - fit(first ind)) / t), where t is a TEMPERATURE. Otherwise the first individual is selected.

The temperature starts at a high value >> 0, and is slowly cut down by multiplying it by a CUTDOWN value every generation. When the temperature reaches 0, then the first individual is selected every time.

The selected individual can be cached so the same individual is returned multiple times without being recomputed. This cache is cleared after `prepareToProduce(...)` is called. Note that this option is not appropriate for Steady State Evolution, which only calls `prepareToProduce(...)` once.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`cache` bool = `true` or `false` (default) | (should we cache the individual?)
base.`temperature` double > 0 (or undefined) | (annealing start temperature)
base.`cutdown` 0.0 <= double >= 1.0 (default is 0.95) | (annealing cutdown)

Default Base
select.annealed

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_ANNEALED`
  Default base
  `static final String`
  `P_CACHE`
  `static final String`
  `P_CUTDOWN`
  `static final String`
  `P_TEMPERATURE`
  `static final double`
  `V_CUTDOWN`

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AnnealedSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `cacheBest(int subpopulation, EvolutionState state, int thread)`
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `prepareToProduce(EvolutionState s, int subpopulation, int thread)`
  A default version of prepareToProduce which does nothing.
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.

  ### Methods inherited from class ec.SelectionMethod

  `finishProducing, produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_ANNEALED

    public static final String P_ANNEALED
    Default base
    See Also:
      - Constant Field Values

  - ### P_CACHE

    public static final String P_CACHE
    See Also:
      - Constant Field Values

  - ### P_TEMPERATURE

    public static final String P_TEMPERATURE
    See Also:
      - Constant Field Values

  - ### P_CUTDOWN

    public static final String P_CUTDOWN
    See Also:
      - Constant Field Values

  - ### V_CUTDOWN

    public static final double V_CUTDOWN
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### AnnealedSelection

    public AnnealedSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState s, int subpopulation, int thread)
    Description copied from class: `SelectionMethod`
    A default version of prepareToProduce which does nothing.
    Overrides:
      `prepareToProduce` in class `SelectionMethod`

  - ### cacheBest

    public void cacheBest(int subpopulation, EvolutionState state, int thread)

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`